; Copyright (C) 1994 by Dan Liddell and Robert Armstrong.
; Copyright (C) 2004 by Spare Time Gizmos.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
; ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
; Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, visit the website of the Free
; Software Foundation, Inc., www.gnu.org.

; code audit comments - wind some of those loops back up - in the row
;  code. Only really need to special case the first few and last few rows
; 
; we don't need no stinkin' loops...
;
;the following register management stuff
;has to go on, in approximately top to bottom hierarchical order:
;
;NEXTGEN handles this stuff:
; handle the upper edge wraparound
; handle the lower edge wraparound
; handle dumping of walking buffer
;
;ONEROW does this stuff:
; handle the left edge wraparound
; handle the right edge wraparound
; handle the middle byte transition
; filling the output buffer
; calling ONEBIT
;
;ONEBIT does this stuff:
; just computes one bits worth of output


; NEXTGEN - perform the computation necessary to tranform the entire bitmap
; to the next generation.
;
; there are no register arguments
;
; as input NEXTGEN assumes the following data areas:
;     a 32 byte array named BITMAP, where the pattern is
;     a 2 byte array named BUFFER0, which is temporary output buffer
;     a 2 byte array named BUFFER1, which is temporary output buffer
;     a 1 bit flag named FLAG_WHICHBUFF, which tells which buffer is available
;
;shamefully, there is no loop in this code. I just call onerow over and 
;over again, with the right arguments. I have traded code space for
;variables (pushing things onto the stack).
;
;top mid bot write-WHICHBUFF      dump WHICHBUFF to row
;----------------------------------------------------
; 15   0   1              0           -
;  0   1   2              1           -
;                                     0           0
;  1   2   3              0      
;                                     1           1
;  2   3   4              1      
;                                     0           2
;  3   4   5              0      
;                                     1           3
;  4   5   6              1      
;                                     0           4
;  5   6   7              0      
;                                     1           5
;  6   7   8              1      
;                                     0           6
;  7   8   9              0      
;                                     1           7
;  8   9  10              1      
;                                     0           8
;  9  10  11              0      
;                                     1           9
; 10  11  12              1      
;                                     0          10
; 11  12  13              0      
;                                     1          11
; 12  13  14              1      
;                                     0          12
; 13  14  15              0
;                                     1          13
; 14  15   0              1
;	                              0          14
;	                              1          15
;				      T           0
;----------------------------------------------------
NEXTGEN:
    mov POP0,#0		; clear the population for this generation
    mov POP1,#0

    clr FLAG_WHICHBUFF

    mov	r1,#BITMAP+(2*15)
    mov r2,#BITMAP+(2* 0)
    mov r3,#BITMAP+(2* 1)
    call onerow

    mov r1,#BUFFERT	; stash row 0 until we do the wraparound
    call dumpbuffer

    setb FLAG_WHICHBUFF

    mov	r1,#BITMAP+(2* 0)
    mov r2,#BITMAP+(2* 1)
    mov r3,#BITMAP+(2* 2)
    call onerow

    clr FLAG_WHICHBUFF

;    mov r1,#BITMAP+(2* 0)	; can't dump to row 0 until we do row
;    call dumpbuffer		; 15, for wraparound. see buffert

    mov	r1,#BITMAP+(2* 1)
    mov r2,#BITMAP+(2* 2)
    mov r3,#BITMAP+(2* 3)
    call onerow

    setb FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 1)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 2)
    mov r2,#BITMAP+(2* 3)
    mov r3,#BITMAP+(2* 4)
    call onerow

    clr FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 2)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 3)
    mov r2,#BITMAP+(2* 4)
    mov r3,#BITMAP+(2* 5)
    call onerow

    setb FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 3)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 4)
    mov r2,#BITMAP+(2* 5)
    mov r3,#BITMAP+(2* 6)
    call onerow

    clr FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 4)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 5)
    mov r2,#BITMAP+(2* 6)
    mov r3,#BITMAP+(2* 7)
    call onerow

    setb FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 5)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 6)
    mov r2,#BITMAP+(2* 7)
    mov r3,#BITMAP+(2* 8)
    call onerow

    clr FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 6)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 7)
    mov r2,#BITMAP+(2* 8)
    mov r3,#BITMAP+(2* 9)
    call onerow

    setb FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 7)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 8)
    mov r2,#BITMAP+(2* 9)
    mov r3,#BITMAP+(2* 10)
    call onerow

    clr FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 8)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 9)
    mov r2,#BITMAP+(2* 10)
    mov r3,#BITMAP+(2* 11)
    call onerow

    setb FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 9)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 10)
    mov r2,#BITMAP+(2* 11)
    mov r3,#BITMAP+(2* 12)
    call onerow

    clr FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 10)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 11)
    mov r2,#BITMAP+(2* 12)
    mov r3,#BITMAP+(2* 13)
    call onerow

    setb FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 11)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 12)
    mov r2,#BITMAP+(2* 13)
    mov r3,#BITMAP+(2* 14)
    call onerow

    clr FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 12)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 13)
    mov r2,#BITMAP+(2* 14)
    mov r3,#BITMAP+(2* 15)
    call onerow

    setb FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 13)
    call dumpbuffer

    mov	r1,#BITMAP+(2* 14)
    mov r2,#BITMAP+(2* 15)
    mov r3,#BITMAP+(2* 0)
    call onerow

    clr FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 14)
    call dumpbuffer

    setb FLAG_WHICHBUFF

    mov r1,#BITMAP+(2* 15)
    call dumpbuffer


    mov r0,#BUFFERT	; now, put row 0 back, now that we have
    mov r1,#BITMAP	; finished using it for wraparound
    mov a,@r0
    mov @r1,a
    inc r0
    inc r1
    mov a,@r0
    mov @r1,a

    ret


; DUMPBUFFER - write the indicated output buffer to the indicated row of
; the array
;
; r1 is the address of the row to dump to
; 
; as input DUMPBUFFER expects the following data areas
;     a 1 bit flag named FLAG_WHICHBUFF, which tells which buffer is available
;
;
; clobbers r0,a
DUMPBUFFER:
    jb FLAG_WHICHBUFF,DUMP2
    mov r0,#BUFFER0
    sjmp DUMPBUFFER1
DUMP2:
    mov r0,#BUFFER1
DUMPBUFFER1:
    mov a,@r0
    mov @r1,a
    inc r0
    inc r1
    mov a,@r0
    mov @r1,a
    ret


; ONEROW - perform the computation necessary to produce one row (2 bytes)
; of output. It assumes that the registers are set up like this:
; 
; r1 is the address of the upper row
; r2 is the address of the center row
; r3 is the address of the lower row
;
; as input ONEROW assumes the following data areas:
;     a 2 byte array named BUFFER0, which is temporary output buffer
;     a 2 byte array named BUFFER1, which is temporary output buffer
;     a 1 bit flag named FLAG_WHICHBUFF, which tells which buffer is available
; 
; It is the caller's responsibility to write the output buffers back to
; the bitmap, and to manage the flag indicating which temporary buffer
; is available to ONEROW.
;
;
; comment notation:
;   below are two alternate representations of a single row of the bitmap:
;
;   L1  L2  L3  L4  L5  L6  L6  L8     L9 L10 L11 L12 L13 L14 L15 L16
;   R16 R15 R14 R13 R12 R11 R10 R9     R8 R7  R6  R5  R4  R3  R2  R1
;
;   L1 is the leftmost, R1 is the rightmost, and so on.
;   O1 is the leftmost result bit, and we never count them from the right.
;
ONEROW:
    mov a,r1		; load the accumulator with RIGHTMOST byte of the row
    mov r0,a
    inc r0
    mov a,@r0
    rrc	a		; rotate it right through the carry
    mov a,r1		; load the a with the LEFTMOST byte of the row
    mov r0,a
    mov a,@r0		
    rrc	a		; rotate it right through the carry

    mov r4,a		; set up the upper buffer

    mov a,r2
    mov r0,a
    inc r0
    mov a,@r0
    rrc	a	
    mov a,r2
    mov r0,a
    mov a,@r0
    rrc	a	

    mov r5,a		; set up the middle buffer

    mov a,r3
    mov r0,a
    inc r0
    mov a,@r0
    rrc	a	
    mov a,r3
    mov r0,a
    mov a,@r0
    rrc	a	

    mov r6,a		; set up the lower buffer

    mov a,r1		; preserve registers across call to onebit
    push acc
    mov a,r2
    push acc
    mov a,r3
    push acc	

; R1  L1  L2  L3  L4  L5  L6  L7     ?   ?   ?   ?   ?   ?   ?   ? 
    call onebit
; L1  L2  L3  L4  L5  L6  L7  R1     ?   ?   ?   ?   ?   ?   ?   O1

    pop	acc		; restore registers across call to onebit
    mov r3,a
    pop acc
    mov r2,a
    pop acc
    mov r1,a

    mov a,r1		; now that we have done the wraparound case,
    mov r0,a
    mov a,@r0		; we can just perform the computation with the
    mov r4,a
    mov a,r2		; leftmost byte
    mov r0,a
    mov a,@r0
    mov r5,a
    mov a,r3
    mov r0,a
    mov a,@r0
    mov r6,a

    mov a,r1		; preserve registers across call to onebit
    push acc
    mov a,r2
    push acc
    mov a,r3
    push acc	

; L1  L2  L3  L4  L5  L6  L7  L8     ?   ?   ?   ?   ?   ?   ?   O1
    call onebit
; L2  L3  L4  L5  L6  L7  L8  L1     ?   ?   ?   ?   ?   ?   O1  O2
    call onebit
; L3  L4  L5  L6  L7  L8  L1  L2     ?   ?   ?   ?   ?   O1  O2  O3
    call onebit
; L4  L5  L6  L7  L8  L1  L2  L3     ?   ?   ?   ?   O1  O2  O3  O4
    call onebit
; L5  L6  L7  L8  L1  L2  L3  L4     ?   ?   ?   O1  O2  O3  O4  O5
    call onebit
; L6  L7  L8  L1  L2  L3  L4  L5     ?   ?   O1  O2  O3  O4  O5  O6
    call onebit
; L7  L8  L1  L2  L3  L4  L5  L6     ?   O1  O2  O3  O4  O5  O6  O7
                  
    pop	acc		; restore registers across call to onebit
    mov r3,a
    pop acc
    mov r2,a
    pop acc
    mov r1,a

; now we have to effect the seamless blending of the current byte
; of the buffer, and the next one.  We start out like this
; c=?    L7  L8  L1  L2  L3  L4  L5 L6

;----------------------------------------------------------------
    mov a,r4 		; load the a with the buffer register

    rlc a
    rlc a

; c=L8   L1  L2  L3  L4  L5  L6  .   L7

    mov r4,a		; store the a into its buffer register 

    mov a,r1		; load the next byte of the row into the accumulator
    mov r0,a
    inc r0
    mov a,@r0

; c=L8   L9  L10 L11 L12 L13 L14 L15 L16

    rrc a		; rotate the a right through the carry

; c=.    L8  L9  L10 L11 L12 L13 L14 L15


    xch a,r4 		; swap the a with the buffer register

; c=.    .   .   .   .   .   .   .   L7

    rrc a		; rotate it right through the carry

; c=L7   .   .   .   .   .   .   .   .

    mov a,r4		; load the buffer register into the a

; c=L7   L8  L9  L10 L11 L12 L13 L14 L15

    rrc a		; rotate the a right through the carry

; c=.    L7  L8  L9  L10 L11 L12 L13 L14

    mov r4,a		; move the a to buffer register
;----------------------------------------------------------------
    mov a,r5		; perform the same operation on the middle row
    rlc a
    rlc a
    mov r5,a
    mov a,r2
    mov r0,a
    inc r0
    mov a,@r0
    rrc a	
    xch a,r5 	
    rrc a	
    mov a,r5	
    rrc a	
    mov r5,a	
;----------------------------------------------------------------
    mov a,r6 		; perform the same operation on the bottom row
    rlc a
    rlc a
    mov r6,a	
    mov a,r3	
    mov r0,a
    inc r0
    mov a,@r0
    rrc a	
    xch a,r6 	
    rrc a	
    mov a,r6	
    rrc a	
    mov r6,a	
;----------------------------------------------------------------

    mov a,r1		; preserve registers across call to onebit
    push acc
    mov a,r2
    push acc
    mov a,r3
    push acc	

; L7  L8  R8  R7  R6  R5  R4  R3     ?   O1  O2  O3  O4  O5  O6  O7
    call onebit
; L8  R8  R7  R6  R5  R4  R3  L7     O1  O2  O3  O4  O5  O6  O7  O8

    pop	acc		; restore registers across call to onebit
    mov r3,a
    pop acc
    mov r2,a
    pop acc
    mov r1,a

    jb FLAG_WHICHBUFF,WALK1
    mov r0,#BUFFER0
    sjmp WRITEBUF
WALK1:
    mov r0,#BUFFER1
WRITEBUF:
    mov a,r7
    mov @r0,a

    mov a,r1		; preserve registers across call to onebit
    push acc
    mov a,r2
    push acc
    mov a,r3
    push acc	

; L8  R8  R7  R6  R5  R4  R3  L7     O1  O2  O3  O4  O5  O6  O7  O8
    call onebit
; R8  R7  R6  R5  R4  R3  L7  L8     O2  O3  O4  O5  O6  O7  O8  O9
    call onebit
; R7  R6  R5  R4  R3  L7  L8  R8     O3  O4  O5  O6  O7  O8  O9  O10
    call onebit
; R6  R5  R4  R3  L7  L8  R8  R7     O4  O5  O6  O7  O8  O9  O10 O11 
    call onebit
; R5  R4  R3  L7  L8  R8  R7  R6     O5  O6  O7  O8  O9  O10 O11 O12  
    call onebit
; R4  R3  L7  L8  R8  R7  R6  R5     O6  O7  O8  O9  O10 O11 O12 O13   

    pop	acc		; restore registers across call to onebit
    mov r3,a
    pop acc
    mov r2,a
    pop acc
    mov r1,a

; it is time to reload the registers again. We need to load the rest
; of the rightmost byte, and one of the leftmost bits, to provide the
; wraparound

; c=.    R4  R3  .   .   .   .   .   .

    mov a,r1		; load the leftmost byte of the row into the a
    mov r0,a
    mov a,@r0

; c=.    L1  L2  L3  L4  L5  L6  L7  L8

    rlc	a		; rotate it left through the carry

; c=L1   L2  L3  L4  L5  L6  L7  L8  .

    inc r0		; load the rightmost byte of the row into the a
    mov a,@r0

; c=L1   R8  R7  R6  R5  R4  R3  R2  R1

    rlc a		; rotate the a left through the carry

; c=R8   R7  R6  R5  R4  R3  R2  R1  L1 

    rlc a		; shift the a left 3 times
    rlc a
    rlc a

; c=.    R4  R3  R2  R1  L1  .   .   .

    mov r4,a		; store into the upper buffer register
;----------------------------------------------------------------
    mov a,r2
    mov r0,a
    mov a,@r0
    rlc	a	
    inc r0	
    mov a,@r0
    rlc a	
    rlc a	
    rlc a
    rlc a
    mov r5,a		; store into the middle buffer register
;----------------------------------------------------------------
    mov a,r3	
    mov r0,a
    mov a,@r0
    rlc	a	
    inc r0	
    mov a,@r0
    rlc a	
    rlc a	
    rlc a
    rlc a
    mov r6,a		; store into the bottom buffer register
;----------------------------------------------------------------

    mov a,r1		; preserve registers across call to onebit
    push acc
    mov a,r2
    push acc
    mov a,r3
    push acc	

; R4  R3  R2  R1  L1  .   .   .      O6  O7  O8  O9  O10 O11 O12 O13   
    call onebit
; R3  R2  R1  L1  .   .   .   R4     O7  O8  O9  O10 O11 O12 O13 O14
    call onebit
; R2  R1  L1  .   .   R4  R3  R2     O8  O9  O10 O11 O12 O13 O14 O15 
    call onebit
; R1  L1  .   .   R4  R3  R2  R1     O9  O10 O11 O12 O13 O14 O15 O16

    pop	acc		; restore registers across call to onebit
    mov r3,a
    pop acc
    mov r2,a
    pop acc
    mov r1,a

    jb FLAG_WHICHBUFF,WALK2
    mov r0,#BUFFER0
    sjmp WRITEBUF2
WALK2:
    mov r0,#BUFFER1
WRITEBUF2:
    inc r0
    mov a,r7
    mov @r0,a

    ret




; ONEBIT: compute the next generation for one bit. assumes the following
; register setup, and assumes that the data in these registers is valid.
; ONEBIT does not load buffer registers from the life bitmap, nor write
; the output buffer to the bitmap. This is left to the caller.
;
;     r4 - upper row buffer
;     r5 - center row buffer
;     r6 - lower row buffer
;     r7 - output buffer
; 
; registers clobbered by this routine are:
;
;     r2 - used for the count of adjacencies
;     r3 - current cell value
;
; r0,r1 are unused
;
; some improvements that could be made are:
;    if we get a large enough subtotal to kill the current cell, we do
;        not need to continue looking at adjacencies. useful only for
;        dense situations. 
;
; first estimate was 496 oscillator periods
; actual oscillator periods: 792 = 38*12 + 14*24
;
ONEBIT:
    mov r2,#0	        ;12 clear the count of adjacencies
    mov r3,#0		;12 assume that the current cell is empty

    mov a,r4	        ;12 get the leftmost byte of a row
    rlc a		;12 get the upper left cell into the carry bit
    jnc OB1		;24 if it is zero, 
    inc r2		;12  then don't increment the count
OB1:
    rlc a		;12 get the upper cell into the carry bit
    jnc OB2		;24
    inc r2		;12
OB2:
    rlc a		;12 get the upper right cell in the carry bit
    jnc OB3		;24
    inc r2		;12
OB3:
    rrc a		;12 set up for the next time in this row
    rrc a		;12 set up for the next time in this row ?
    mov r4,a		;12

    mov a,r5	        ;12 get the leftmost byte of a row
    rlc a		;12 get the left cell into the carry bit
    jnc OB4		;24 if it is zero, 
    inc r2		;12  then don't increment the count
OB4:
    rlc a		;12 get the value of current cell into the carry bit..
    jnc SKIPCELL	;24
    inc r3		;12 ..and stash it in register 3 
SKIPCELL:
    rlc a		;12 get the right cell in the carry bit
    jnc OB5		;24
    inc r2		;12
OB5:
    rrc a		;12 set up for the next time in this row
    rrc a		;12 set up for the next time in this row
    mov r5,a		;12

    mov a,r6	        ;12 get the leftmost byte of a row
    rlc a		;12 get the lower left cell into the carry bit
    jnc OB6		;24 if it is zero, 
    inc r2		;12  then don't increment the count
OB6:
    rlc a		;12 get the lower cell into the carry bit
    jnc OB7		;24
    inc r2		;12
OB7:
    rlc a		;12 get the lower right cell in the carry bit
    jnc OB8		;24
    inc r2		;12
OB8:
    rrc a		;12 set up for the next time in this row
    rrc a		;12 set up for the next time in this row
    mov r6,a		;12

    mov a,r2		;12 get the count of adjacencies
    cjne a,#2,NOSURV	;24 see if it has 2 neighbors
    sjmp KNOW		;24
NOSURV:
    mov a,r2		;12 get the count of adjacencies
    cjne a,#3,NOBIRT	;24 see if it has 3 neighbors
    mov r3,#1		;12
    sjmp KNOW		;24
NOBIRT:
    mov r3,#0		;12 less than 2 or more than 3: dead
KNOW:
    mov a,r3		;12 get disposition of current cell...
    rrc	a		;12   into the carry bit
    mov	a,r7		;12 get the buffer line under construction
    rlc	a		;12 and move that bit into it
    mov r7,a		;12 put it back

    cjne r3,#1,OBD	; do we need to increment the population? usually not

    mov a,POP0		; increment the current population
    add a,#1
    mov POP0,a
    clr a
    addc a,POP1
    mov POP1,a
    
OBD:
    ret			;24


; run for a specified number of generations. No more, maybe less. Min0 is
; the variable that contains the count. return last input byte read in a
RUNJUST:
    mov a,MIN0
    jz RUNEXIT			; exit because we have run enough gens
    call nextgen
    dec MIN0			; decrement number of generations left
    jnb FLAG_DISPLAYLIFE,RUNJUSTNODISP
    call display_update
RUNJUSTNODISP:
    mov a,SPEED
    jz RUNJUSTMAYBE		; are we running full speed?
    call wait			; no. WAIT can return token that prematurely
    jnz RUNJUSTEXIT		;    ended the waiting period.
RUNJUSTMAYBE:
    mov a,POP0
    jz RUNEXIT			; exit if there is nothing on the screen
    sjmp RUNJUST

RUNEXIT:			; exit, and clear the accumulator
    clr a
RUNJUSTEXIT:			; exit, with the token that we read. caller
    ret				;    will process it


; run at least min0 generations, then allow oscillation detection to take
; over. return with any key input in a, to allow for speedy mode changes
RUNATLEAST:
    mov a,MIN0
    jz RUNUNTIL			; we have run it the minimum number of gens
    call nextgen
    jnb FLAG_DISPLAYLIFE,RUNATLEASTNODISP
    call display_update
RUNATLEASTNODISP:
    mov a,SPEED
    jz LEASTSKIP		; we are running at full speed.ignore keyboard
    mov a,SPEED			; we are not running full speed. 
    call wait			; WAIT can return a token that was read
    jnz RUNLEASTJUSTEXIT	;   return if this is the case
LEASTSKIP:
    dec MIN0			; decrement number of generations left to run
    sjmp RUNATLEAST
RUNLEASTJUSTEXIT:
    ret				; token press ended run. caller processes

; run until we collect enough information to know that we are oscillating
; this is kind of tricky. collect the minimum population, and count the
; number of generations between identical minima, and quit when we are sure
; of the oscillation. return last input read in a
;
; GEN0 and GEN1 are a count of maximum number of generations to run.
;
; rununtil has a few problems. say your population statistics look like
; 11 9 9 8 9 8 9 <repeat>
; well, I found this out after I wrote it. The minimum might not be 
; unique. We could add another variable, and after some time use it
; to identify how many times we should try to skip the minimum.
RUNUNTIL:
    mov MIN0,#0FFH		; initialize minimum population statistic
    mov CYCLE,#0		; initialize # of gens since last minimum
    mov LCYCLE,#0		; initialize the last CYCLE
    mov CYCLES,#0		; initialize the total number of cycles seen
RUNUNTILLOOP:
    call nextgen		; get the next generation
    jnb FLAG_DISPLAYLIFE,RUNUNTILNODISP
    call display_update		; display it
RUNUNTILNODISP:
    mov a,GEN1			; decide if we have expended the countdown
    jnz RUNUNTILDEC
    mov a,GEN0
    jz	RUNUNTILEXIT		; count is zero. quit
RUNUNTILDEC:
    mov a,GEN0
    clr c			; decrement the count
    subb a,#1
    mov GEN0,a
    mov a,GEN1
    subb a,#0
    mov GEN1,a

    mov a,SPEED
    jz UNTILSKIP		; if we are running full blast,ignore keyboard
    mov a,SPEED			; keyboard press can prematurely end wait
    call wait			
    jnz RUNUNTILJUSTEXIT
UNTILSKIP:
    inc CYCLE			; increment length of cycle since last minimum

    mov a,POP0
    jz RUNUNTILEXIT		; no survivors... exit
    cjne a,MIN0,NOTSAME		; compare current population to last minimum

    mov a,CYCLE			; we have found a repeated population minimum!
    cjne a,LCYCLE,NOTREPEAT	; compare this cycle length to last cycle

    mov CYCLE,#0		; reset count of length of current cycle

    inc CYCLES			; increment the number of cycles we have seen

    mov a,CYCLES
    cjne a,#3,RUNUNTILLOOP	; compare number of times we have cycled
    sjmp RUNUNTILEXIT		; cycled enough. exit, with no tokens read

; if the current population is not the same as the minimum population we have
; seen so far, then we have to check to see if it is a new minimum.
; if it is a new minimum, then we have to restart the count of generations
; in the current cycle.
NOTSAME:
    jnc NOTSAME2		; check for new minimum.

    mov MIN0,POP0		; capture new minimum, reset everything else
    mov LCYCLE,#0
    mov CYCLE,#0
    mov CYCLES,#0
    sjmp RUNUNTILLOOP
NOTSAME2:
    mov a,CYCLE			; has the current cycle been going on 
    cjne a,#30,NOTSAME3		;  too long to be useful? 
NOTSAME3:			
    jc RUNUNTILLOOP
    mov MIN0,#0FFH		; yes. reset minimum population statistic

    mov LCYCLE,#0
    mov CYCLE,#0
    mov CYCLES,#0
    sjmp RUNUNTILLOOP


; if we have seen a minimum, but it is a different distance from the last
; time we hit the minimum, then we have to readjust the length of the 
; cycle.
NOTREPEAT:
    mov LCYCLE,CYCLE		; this cycle length becomes prev cycle length
    mov CYCLE,#0		; and reset the number of cycles we have seen
    mov CYCLES,#0		; and reset the number of cycles we have seen
    sjmp RUNUNTILLOOP

RUNUNTILEXIT:			; exit, saying we read no tokens
    clr a	
RUNUNTILJUSTEXIT:		; exit, leaving token undisturbed
    ret

; Bob's demo mode for life. Take a bunch of oldies but goodies, and
; run them until they stabilize, or until we get tired of them
;
; FLAG_DOFADEUP used for mode change, to say whether or not to fade up
; or just assume display is ok.
;
LIFEDEMO:
    clr FLAG_DONTADVANCE        ; advance normally
    setb FLAG_DISPLAYLIFE	; say that we want to see the generations
    mov		SPEED,#HERTZ/5

LD0:
    MOV DPTR,#BLINKS
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD1:
    MOV DPTR,#GLIDERS3
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD2:
    MOV DPTR,#PENTADECATHALON
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD3:
    MOV DPTR,#FIVE
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD4:
    MOV DPTR,#PULSAR
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD5:
    MOV DPTR,#AGAR
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD6A:
    MOV DPTR,#AGAR1
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD6:
    MOV DPTR,#LINES
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD7:
    MOV DPTR,#TUMBLER		; gives runatleast fits?
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD8:
    MOV DPTR,#POLES
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD8A:
    MOV DPTR,#Q2
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD8B:
    MOV DPTR,#PIVOT
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD9:
    MOV DPTR,#CLOCK
    call LIFEDEMOONE
    jnz LIFEDEMORET
LD10:
    ajmp LD0
LIFEDEMORET:
    ret

; set up dptr in advance with the pattern that you want to see.
; this will run it for as close to 10 seconds as it can manage.
LIFEDEMOONE:
    mov ELAPSEDTIME,#0			; clear the timer. it counts seconds
    call LOAD_BITMAP
    call DISPLAY_UPDATE

    jnb FLAG_DOFADEUP,LIFEDEMOONE1	; do fadeup?
    call FADEUP				; yes.
    jnz LIFEDEMOCOM			; handle user input
LIFEDEMOONE1:
    setb FLAG_DOFADEUP
    mov min0,#10			; two seconds @ 5 gens/per second
    call RUNJUST
    jnz LIFEDEMOCOM			; handle user input
LIFEDEMOONE2:
    mov a,ELAPSEDTIME	
    cjne a,#9,$+3			; do a comparison, to see if 10 secs
    jc LIFEDEMOONE1			; has gone by
    jb FLAG_DONTADVANCE,LIFEDEMOONE1	; are we to advance to next pattern?
    call fadedown			; yes. 
    clr a				; say no input
    ret

; examine the keycode that we have received, and dispatch it to the
; right place. 
;
LIFEDEMOCOM:
    jz LIFEDEMODONEC
    cjne a,#CMD_FASTER,LIFEDEMOC2
    call LIFEDEMOCFAST
    sjmp LIFEDEMODONEC
LIFEDEMOC2:
    cjne a,#CMD_SLOWER,LIFEDEMOC4
    call LIFEDEMOCSLOW
    sjmp LIFEDEMODONEC
LIFEDEMOC4:
    cjne a,#CMD_NEXTPATTERN,LIFEDEMOC6
    sjmp LIFEDEMONEXT		; go to next pattern without bombing out
LIFEDEMOC6:		; we don't know what we got
    cjne a,#CMD_AUTOADVANCE,LIFEDEMOC8
    sjmp LIFEDEMOTOGGLE
LIFEDEMOC8:
    cjne a,#CMD_BRIGHTNESS,LIFEDEMOC10
    call LEDCHANGE
    sjmp LIFEDEMODONEC

;
; end of the input ladder, and we don't know what it is. return it to 
; the caller
;
LIFEDEMOC10:
    ret

; end of the command chain, where we jump back and continue the pattern
;
LIFEDEMODONEC:
    ajmp LIFEDEMOONE1

; do what it takes to increase the speed of the passing generations
;
LIFEDEMOCFAST:
    mov a,SPEED
    cjne a,#1,LDFNORM
    sjmp LDFBEEP
LDFNORM:
    clr c
    subb a,#HERTZ/8
    jz LDFTOO
    jc LDFTOO
    mov SPEED,a
    ret
LDFTOO:
    mov SPEED,#1
    ret
LDFBEEP:
    call long_beep
    ret

; do what it takes to decrease the speed of the passing generations
;
LIFEDEMOCSLOW:
    mov a,SPEED
    cjne a,#HERTZ,LDSNORM
    sjmp LDSBEEP
LDSNORM:
    add a,#HERTZ/8
    cjne a,#HERTZ,LDSNEXT		; just to get the carry bit set
LDSNEXT:
    jnc LDSTOO
    mov SPEED,a
    ret
LDSTOO:
    mov SPEED,#HERTZ
    ret
LDSBEEP:
    call LONG_BEEP
    ret

; just move along the next generation
;
LIFEDEMONEXT:				; just interrupt the current pattern
    clr a				; and get on to the next one
    ret

; toggle advance mode. 
;
LIFEDEMOTOGGLE:				; toggle advance mode. IF the bit
    jnb FLAG_DONTADVANCE,LIFEDEMOT2	; is set, then advance to next 
    clr FLAG_DONTADVANCE		; pattern only under command. If the
    sjmp LIFEDEMODONEC			; bit is not set, then move on to
LIFEDEMOT2:				; next command after 10 seconds
    setb FLAG_DONTADVANCE
    sjmp LIFEDEMODONEC

; the patterns.
BLINKS:
	DB	00000000B,00000000B,
	DB	00000000B,00001000B,
	DB	00010000B,00001000B,
	DB	00110000B,00001000B,
	DB	00110000B,00000000B,
	DB	00100000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,11100000B,
	DB	00000000B,11100000B,
	DB	00000000B,11100000B,
	DB	00000000B,00011100B,
	DB	00000000B,00011100B,
	DB	00001100B,00011100B,
	DB	00001100B,00000000B,
	DB	00110000B,00000000B,
	DB	00110000B,00000000B,

GLIDERS3:
	DB	01000000B,00000000B,
	DB	00100000B,00000000B,
	DB	11100000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000010B,00000000B,
	DB	00000100B,00000000B,
	DB	00000111B,00000110B,
	DB	00000000B,00000110B,
	DB	00000000B,00000000B,
	DB	00000000B,00010000B,
	DB	00000000B,00001000B,
	DB	00000000B,00111000B,
	DB	00000011B,00000000B,
	DB	00000011B,00000000B,
	DB	00000000B,00000000B,

PENTADECATHALON:
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00011111B,11111000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,

LINES:
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	11111111B,11111111B,
	DB	11111111B,11111111B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,

FIVE:
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,11111000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00111110B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,
	DB	00000000B,00000000B,


AGAR:
	DB	00000000B,00000000B,
	DB	01101101B,10110110B,
	DB	01101101B,10110110B,
	DB	00000000B,00000000B,
	DB	01101101B,10110110B,
	DB	01101101B,10110110B,
	DB	00000000B,00000000B,
	DB	01101101B,10110110B,
	DB	01101101B,10110110B,
	DB	00000000B,00000000B,
	DB	01101101B,10110110B,
	DB	01101101B,10110110B,
	DB	00000000B,00000000B,
	DB	01101101B,10110110B,
	DB	01101101B,10110110B,
	DB	00000000B,00000000B,

AGAR1:
	DB	00000000B,00000000B,
	DB	01101101B,10110110B,
	DB	01101101B,10110110B,
	DB	00000000B,00000000B,
	DB	01101101B,10110110B,
	DB	01101101B,10110110B,
	DB	00000000B,00000000B,
	DB	01101111B,10110110B,
	DB	01101101B,10110110B,
	DB	00000000B,00000000B,
	DB	01101101B,10110110B,
	DB	01101101B,10110110B,
	DB	00000000B,00000000B,
	DB	01101101B,10110110B,
	DB	01101101B,10110110B,
	DB	00000000B,00000000B,
 
TUMBLER:
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000011B,01100000B
        db      00000011B,01100000B
        db      00000001B,01000000B
        db      00000101B,01010000B
        db      00000101B,01010000B
        db      00000110B,00110000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B

PULSAR:
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000011B,11100000B
        db      00000010B,00100000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B

POLES:
        db      00000000B,00000000B
        db      00000000B,00000110B
        db      01100000B,00000010B
        db      01010000B,00010100B
        db      00000000B,00100000B
        db      00010100B,00110000B
        db      00000000B,00000000B
        db      00000101B,00000000B
        db      11000000B,00000000B
        db      10100001B,01000000B
        db      00000000B,00000000B
        db      00101000B,01010000B
        db      00000000B,00000000B
        db      00001010B,00010100B
        db      00000001B,00001100B
        db      00000011B,00000000B
CLOCK:
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000011B,00000000B
        db      00000011B,00000000B
        db      00000000B,00000000B
        db      00000011B,11000000B
        db      00000100B,10101100B
        db      00000101B,00101100B
        db      00110100B,01100000B
        db      00110100B,00100000B
        db      00000011B,11000000B
        db      00000000B,00000000B
        db      00000000B,11000000B
        db      00000000B,11000000B
        db      00000000B,00000000B
        db      00000000B,00000000B

Q2:
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      01111100B,01111100B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      01111100B,01111100B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B

PIVOT:
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00011011B,00000000B
        db      00010001B,00000000B
        db      00001110B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00001110B,00000000B
        db      00010001B,00000000B
        db      00011011B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B
        db      00000000B,00000000B




