; Copyright (C) 1994 by Dan Liddell and Robert Armstrong.
; Copyright (C) 2004 by Spare Time Gizmos.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
; ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
; Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, visit the website of the Free
; Software Foundation, Inc., www.gnu.org.

; random. just access memory, and write it to the screen. It should make a 
; nice random dazzle (jeffy). currently, all of memory is between 
; SYSTEM_STARTUP and COPYRIGHT
;
DAZZLE:
    call CLEARSCREEN
DAZZLEA:
    mov DPTR,#SYSTEM_STARTUP
    mov r1,#((COPYRIGHT-SYSTEM_STARTUP) / 256)
DAZZLE3:
    mov r2,#128		; count of number of times we should load the bitmap
DAZZLE4:
    mov a,#32
    call scrolldown
DAZZLE5:
    clr a
    movc a,@a+DPTR
    inc DPTR
    mov r0,#BITMAP
    mov @r0,a

    clr a
    movc a,@a+DPTR
    inc DPTR
    mov r0,#BITMAP+1
    mov @r0,a

    push ar0
    push ar1
    push ar2
    call DISPLAY_UPDATE
    pop ar2
    pop ar1
    pop ar0
    jnb FLAG_DOFADEUP,DAZZLE6
    push ar0
    push ar1
    push ar2
    call FADEUP
    pop ar2
    pop ar1
    pop ar0
    clr FLAG_DOFADEUP
    jnz DAZZLERET
DAZZLE6:
    push ar0
    push ar1
    push ar2
    mov a,#HERTZ/40
    call WAIT
    pop ar2
    pop ar1
    pop ar0
    jnz DAZZLERET

    djnz r2,DAZZLE4	; any more bitmaps to load for this 256 bytes?

    djnz r1,DAZZLE3	; any more blocks of 256 bytes to process?
    sjmp DAZZLEA

DAZZLERET:
    ret

; scrolldown - scroll the bitmap down one line
; a contains the number of bytes to do (two bytes per line)
SCROLLDOWN:
    push ar0
    push ar1
    push ar2
    mov r0,#BITMAP+29
    mov r1,#BITMAP+31
    mov r2,a
SCROLLDOWN1:
    mov a,@r0
    mov @r1,a
    djnz r2,SCROLLDOWN2
    pop ar2
    pop ar1
    pop ar0
    ret
SCROLLDOWN2:
    dec r0
    dec r1
    sjmp SCROLLDOWN1

; scrollup - scroll the bitmap up one line
; a contains the number of bytes to do (two bytes per line)
SCROLLUP:
    push ar0
    push ar1
    push ar2
    mov r2,a
    mov r0,#BITMAP
    mov r1,#BITMAP+2
SCROLLUP1:
    mov a,@r1
    mov @r0,a
    djnz r2,SCROLLUP2
    pop ar2
    pop ar1
    pop ar0
    ret
SCROLLUP2:
    inc r0
    inc r1
    sjmp SCROLLUP1

; did this accidentally once, and it turned out pretty well.
; run life almost as fast as possible, and each time you get
; a command (except for the next-mode-command), put it into 
; the middle of the screen. Life flares and burns around it,
; and it is not predictable.
LIFEBURN:
    setb FLAG_DOFADEDOWN		; say that a fadedown is needed
    setb FLAG_DISPLAYLIFE		; say that we want to see each gnrtn
    call CLEARSCREEN
    call DISPLAY_UPDATE			; clear the screen
    jnb FLAG_DOFADEUP,LB2		; see if we should do a fadeup
    call FADEUP
    clr FLAG_DOFADEUP
    mov SPEED,#1			; maximum speed
LB2:
    mov MIN0,#1				; but just for one generation
    call RUNJUST			
    jz LB2				; if no input, do it again
;
    cjne a,#CMD_FASTER,LBCOM2
    call LIFEDEMOCFAST
    sjmp LB2
LBCOM2:
    cjne a,#CMD_SLOWER,LBCOM4
    call LIFEDEMOCSLOW
    sjmp LB2
LBCOM4:
    cjne a,#CMD_BRIGHTNESS,LBCOM6
    call LEDCHANGE
    sjmp LB2
LBCOM6:
    cjne a,#CMD_NEXTMODE,LBCOM7
    ret			; now return to our caller's caller
LBCOM7:
    push acc
    anl a,#0FH
    orl a,BITMAP+16
    mov BITMAP+16,a
    pop acc
    push acc
    rlc a
    rlc a
    rlc a
    rlc a
    orl a,BITMAP+17
    mov BITMAP+17,a
    pop acc

    push acc
    anl a,#0FH
    orl a,BITMAP+18
    mov BITMAP+18,a
    pop acc
    push acc
    rlc a
    rlc a
    rlc a
    rlc a
    orl a,BITMAP+19
    mov BITMAP+19,a
    pop acc

    sjmp LB2
