; Copyright (C) 1994 by Dan Liddell and Robert Armstrong.
; Copyright (C) 2004 by Spare Time Gizmos.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful, but
; WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
; ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
; Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, visit the website of the Free
; Software Foundation, Inc., www.gnu.org.

; fade to black.
; return in a the keycode that interrupted this operation, if
; any. if we interrupted while we are fading, then just slam it to
; black, and then return. from max bright to black in one half second
FADEDOWN:
        push INTENSITY		; save current intensity
FADEDOWN1:
	MOV	A, #HERTZ / 30
	CALL	WAIT		; ...
	jz FADEDOWN2		; no user input
	
	push acc
	clr a
	call SET_INTENSITY
	pop acc			; restore the character that caused exit
	pop INTENSITY		; restore the intensity value.
	ret
FADEDOWN2:
	MOV	A, INTENSITY	; get the current display brightness
	CALL	SET_INTENSITY	; and tell the hardware
	MOV	A, INTENSITY	; get the current display brightness
	jz	FDRET
	dec 	INTENSITY
	sjmp	FADEDOWN1
FDRET: 
	clr a			; say that we were not interrupted
	pop INTENSITY		; restore the intensity value
	ret			; by a keypress

; fade to white
; return in a the keycode that caused us to interrupt our slow, one
; second progress from black to white
FADEUP:
	push INTENSITY
	mov a,#0
	CALL SET_INTENSITY
FADEUP1:
	MOV	A, #HERTZ / 30	; wait for a sixteenth
	CALL	WAIT		; ...
	jz FADEUP2
	sjmp FADEUPJUSTEXIT
FADEUP2:
	pop acc			; get the saved maximum intensity
	push acc		; save it again
	clr c			; get ready for compare of max to current
	subb a,INTENSITY
	jnz FADEUP3
	sjmp FADEUPEXIT
FADEUP3:
	mov a,INTENSITY
	CALL	SET_INTENSITY	; and tell the hardware
	inc INTENSITY
	JMP	FADEUP1

FADEUPEXIT:
	pop acc
	call set_intensity
	clr a
	ret
FADEUPJUSTEXIT:
	pop INTENSITY		; get configured max intensity
	push acc		; save the character to return
	mov a,intensity
	call SET_INTENSITY	; and set it
	pop acc			; restore the character
        ret

; clear the bitmap to zeros
CLEARSCREEN:
    mov r0,#BITMAP	; just clear the display for now
    mov r1,#BITMAP_SIZE
    clr a
CLEARSCREEN1:
    mov @r0,a
    inc r0
    djnz r1,CLEARSCREEN1
    ret
